#ifndef DVPCOLLATE_H_INCLUDED
#define DVPCOLLATE_H_INCLUDED

/**
 * @file DVPCollate.h
 * @author Loc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#include <locale>
#include <string>

//! Comparaison de chane, insensible  la case et aux accents
/**
 * Comparaison de chane de caractre insensible  la case et aux accents.
 * Pour l'instant elle ne gre que les wchar_t.
 */
template<typename _CharT>
class DVPCollate : public std::collate<_CharT>
{
  typedef std::basic_string<_CharT> string_t;

protected:
  //! Comparaison de chane, insensible  la case et aux accents
	virtual int do_compare(
    const _CharT* __lo1,
    const _CharT* __hi1,
    const _CharT* __lo2,
    const _CharT* __hi2) const;

  //! Transformation en chanes sans accent ni majuscule
	virtual std::basic_string<_CharT> do_transform(
    const _CharT* __lo,
    const _CharT* __hi) const;

  //! Calcule une valeur de hachage, insensible  la case et aux accents
	virtual long do_hash(
    const _CharT* __lo,
    const _CharT* __hi) const;
};

#endif // DVPCOLLATE_H_INCLUDED
