/**
 * @file DVPStationDBLoader.h
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#ifndef DVPSTATIONDBFILLER_H_INCLUDED
#define DVPSTATIONDBFILLER_H_INCLUDED

#include "IStationDBLoader.h"

//! Chargeur de base pour les fichiers de developpez.com
/**
 * Remplit une StationsDB, à partir d'un fichier au format
 * imposé par developpez.com.
 * Correspond a l'interface IStationDBFiller.
 * @see IStationDBFiller
 * @see StationsDB
 */
class DVPStationDBLoader : public IStationDBLoader
{
	std::string sourceFile_;

public:
	DVPStationDBLoader(
    const std::string &fileName /**< [in] Nom du fichier source */):
		sourceFile_(fileName)
	{
	}

	//! Remplit le StationsDB à partir du fichier
	virtual void load(StationsDB &);
};

#endif // DVPSTATIONDBFILLER_H_INCLUDED
