#ifndef DISPLAY_H_INCLUDED
#define DISPLAY_H_INCLUDED

/**
 * @file Display.h
 * @author Loc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#include <string>
#include <boost/noncopyable.hpp>

class PathResult;
class StationsDB;

//! Reprsente l'interface utilisateur
class Display : boost::noncopyable
{
public:
  //! Affiche le rsultat
	void displayResult(
    const PathResult &result /**< [int] chemin qui va tre afficher */);

  //! Demande la dure entre deux stations
	void queryStepDuration(
    int& /**< [out] Dure entre par l'utilisateur */);

	//! Demande la dure d'une correspondance
	void queryChangeDuration(
    int& /**< [out] Dure entre par l'utilisateur */);

	//! Demande le nom de la station de dbut
	void queryStartStation(
    std::wstring& /**< [out] Nom entr par l'utilisateur */);

  //! Redemande le nom d'une station intermdiaire
  void queryIntermediateStation(
    std::wstring& /**< [in,out] Nom de la station intermdiaire a prciser */);

	//! Demande le nom de la station de fin
	void queryEndStation(
    std::wstring& /**< [out] Nom entr par l'utilisateur */);

	//! Signal une erreur de lecture de la base de donne
	void dataBaseLoadError(
    const std::wstring& /**< [in] Message d'erreur  afficher */);
};

#endif // DISPLAY_H_INCLUDED
