/**
 * @file Line.cpp
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#include "Line.h"

using std::wstring;

Line::Line(
  int id,
  const std::wstring &name):
		name_(name),
		id_(id)
{
}

SharedLine Line::Create(
  int id,
  const std::wstring &name)
{
	return SharedLine(new Line(id, name));
}

void Line::addStation(SharedConstStation newStation)
{
	stationVect_.push_back(newStation);
}

SharedConstStation Line::getEndStationInThisDirection(
  SharedConstStation X,
  SharedConstStation Y) const
{
  const_iterator iterX = std::find(stationVect_.begin(), stationVect_.end(), X);
  const_iterator iterY = std::find(stationVect_.begin(), stationVect_.end(), Y);
  assert(iterX != iterY);
  assert(iterX != stationVect_.end());
  assert(iterY != stationVect_.end());
  if(iterX < iterY)
    return stationVect_.back();
  else
    return stationVect_.front();
}

