/**
 * @file PathResult.cpp
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#include "PathResult.h"

#include "Station.h"
#include "Line.h"

PathResult::Step::Step(
	SharedConstStation sta1,
	SharedConstStation sta2,
	SharedConstLine li,
	unsigned int chaDur,
	unsigned int traDur
):
		station1(sta1),
		station2(sta2),
		line(li),
		changeDuration(chaDur),
		transportDuration(traDur)
{
}

PathResult::PathResult():
		totalSecondDuration_(0)
{
}

void PathResult::addStep(const Step &newStep)
{
	totalSecondDuration_ += newStep.changeDuration;
	totalSecondDuration_ += newStep.transportDuration;
	stepList_.push_back(newStep);
}

