/**
 * @file Station.h
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#ifndef STATION_H_INCLUDED
#define STATION_H_INCLUDED

#include <string>
#include <boost/noncopyable.hpp>
#include <boost/shared_ptr.hpp>

//! Contient les données d'une station
class Station : boost::noncopyable
{
	const std::wstring name_;
	int id_;
	Station(int id, const std::wstring &name);

public:

	static boost::shared_ptr<const Station> Create(
    int id,
		const std::wstring &name);

	const std::wstring& getName() const;

	int getID() const;
};

typedef boost::shared_ptr<const Station> SharedConstStation;
typedef boost::shared_ptr<Station> SharedStation;

inline const std::wstring& Station::getName() const
{
	return name_;
}

inline int Station::getID() const
{
  return id_;
}

#endif // STATION_H_INCLUDED
