/**
 * @file utf16_codecvt_facet.cpp
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#include "utf16_codecvt_facet.h"

#include <iostream>

using std::codecvt_base;

template<class Intern>
codecvt_base::result utf16_codecvt_facet<Intern>::do_in(
	std::mbstate_t&,
	const char * from,
	const char * from_end,
	const char * & from_next,
	Intern * to,
	Intern * to_end,
	Intern*& to_next) const
{
	while (from < (from_end - 1) && to != to_end)
	{
		//Pour passer le BOM
		if ((*from == -1) && (*(from + 1) == -2))
		{
			from += 2;
			continue;
		}
		//Pour passer 1 caractère sur les deux du retour chariot
		if ((*from == 0x0D) && (*(from + 1) == 0x00))
		{
			from += 2;
			continue;
		}

		from++;
		*to = *from;
		from--;
		*to |= (*from) & 0xFF;
		from += 2;
		to++;
	}

	from_next = from;
	to_next = to;

	if (from == from_end)
		return codecvt_base::ok;
	else
		return codecvt_base::partial;
}

template<class Intern>
bool utf16_codecvt_facet<Intern>::do_always_noconv() const throw()
{
	return false;
}

template<class Intern>
int utf16_codecvt_facet<Intern>::do_max_length() const throw()
{
	return 2;
}

template class utf16_codecvt_facet<wchar_t>;
template class utf16_codecvt_facet<char>;
