/**
 * @file utf16_codecvt_facet.h
 * @author Loïc HAMOT
 * @date 06/2009
 *
 * La distribution et l'usage sous forme de source ou binaire,
 * avec ou sans modification, sont permis sans restriction.
 * En particulier, je donne mon accord au site developpez.com
 * pour l'utilisation de tout ou partie des sources et de la documentation
 * de ce projet dans les pages developpez.com
 */

#ifndef UTF8_CODECVT_H_INCLUDED
#define UTF8_CODECVT_H_INCLUDED

#include <locale>

//! Lis un flux en UTF-16-LE
/**
 * Cette class a été faite pour lire le fichier "ListeStationsUnicode.txt"
 * et tout fichier possédant le même encodage.
 * Seuls les caractères latin-1 sont gérés. A priori ca suffit pour le défi.
 * (Sauf si on met le métro de tokyo, avec des caractères japonais, mais là...
 *   ...on est pas sorti de l'auberge)
 *
 * Le type std::mbstate_t est différent d'un compilateur à un autre,
 * et ça m'a posé des problèmes pour le do_out, donc je l'ai retiré
 * du code, car on en a pas besoin dans le cas présent.
 */
template<class Intern = wchar_t>
class utf16_codecvt_facet : public std::codecvt<Intern, char, std::mbstate_t>
{
protected:
	virtual std::codecvt_base::result do_in(
		std::mbstate_t& state,
		const char * from,
		const char * from_end,
		const char * & from_next,
		Intern * to,
		Intern * to_end,
		Intern*& to_next) const;

	virtual bool do_always_noconv() const throw();

	virtual int do_max_length() const throw();
};

#endif // UTF8_CODECVT_H_INCLUDED
